"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b ||= {})
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/route/index.tsx
var route_exports = {};
__export(route_exports, {
  Autocomplete: () => autocomplete_default,
  Combobox: () => combobox_default,
  RouteAutocomplete: () => autocomplete_default2,
  RouteCombobox: () => combobox_default2,
  RouteSearchSelect: () => searchSelect_default2,
  RouteSelect: () => select_default2,
  RouteTreeSelect: () => treeSelect_default2,
  SearchSelect: () => searchSelect_default,
  Select: () => select_default,
  TreeSelect: () => treeSelect_default,
  default: () => route_default
});
module.exports = __toCommonJS(route_exports);

// src/route/select.tsx
var import_react3 = __toESM(require("react"));

// src/common/routeHooks.ts
var import_react_router_dom = require("react-router-dom");
function useRouteSelect(options, filterName, emptyValue) {
  const [searchParams, setSearchParams] = (0, import_react_router_dom.useSearchParams)();
  const optionValues = searchParams.getAll(filterName);
  const selectedOptions = options.filter((x) => optionValues.includes(x.value));
  const onChange = (option) => {
    searchParams.delete(filterName);
    if (option) {
      if (Array.isArray(option)) {
        option.forEach((x) => {
          searchParams.append(filterName, x.value);
        });
      } else {
        searchParams.set(filterName, option.value);
      }
    } else if (emptyValue) {
      searchParams.set(filterName, "");
    }
    setSearchParams(searchParams, { replace: true });
  };
  return {
    optionValues,
    selectedOptions,
    onChange
  };
}

// src/select.tsx
var import_classnames = __toESM(require("classnames"));
var import_react = __toESM(require("react"));
var import_react2 = require("@headlessui/react");
var import_solid = require("@heroicons/react/20/solid");
function Select({
  className,
  options,
  selectedOption,
  selectedOptions,
  onChange,
  multiple,
  placeholder,
  isLoading,
  filter,
  resetButton = true
}) {
  const selectedValue = multiple ? selectedOptions : selectedOption;
  const selectedLabel = multiple ? selectedOptions == null ? void 0 : selectedOptions.map((x) => x.label).join(", ") : selectedOption == null ? void 0 : selectedOption.label;
  return /* @__PURE__ */ import_react.default.createElement(
    import_react2.Listbox,
    {
      value: selectedValue || null,
      onChange,
      multiple,
      as: "div",
      className: (0, import_classnames.default)("relative", className)
    },
    /* @__PURE__ */ import_react.default.createElement(
      import_react2.Listbox.Button,
      {
        className: (0, import_classnames.default)(
          "form-input relative w-full cursor-default pl-3 pr-10 text-left",
          filter ? "form-input-filter" : ""
        )
      },
      /* @__PURE__ */ import_react.default.createElement(
        "span",
        {
          title: selectedLabel,
          className: (0, import_classnames.default)(
            "block truncate",
            selectedLabel ? "" : "text-secondary-500"
          )
        },
        selectedLabel || placeholder
      ),
      (!resetButton || !selectedLabel) && /* @__PURE__ */ import_react.default.createElement("span", { className: "pointer-events-none absolute inset-y-0 right-2 flex items-center" }, /* @__PURE__ */ import_react.default.createElement(import_solid.ChevronDownIcon, { className: "h-5 w-5", "aria-hidden": "true" }))
    ),
    resetButton && selectedLabel && /* @__PURE__ */ import_react.default.createElement(
      "button",
      {
        type: "button",
        className: "form-input-clear absolute z-10 right-2.5 inset-y-0 my-auto h-5 px-0.5",
        onClick: () => {
          if (multiple) {
            onChange([]);
          } else {
            onChange(null);
          }
        }
      },
      /* @__PURE__ */ import_react.default.createElement(import_solid.XMarkIcon, { className: "h-4 w-4", "aria-hidden": "true" })
    ),
    /* @__PURE__ */ import_react.default.createElement(
      import_react2.Transition,
      {
        as: import_react.Fragment,
        leave: "transition ease-in duration-100",
        leaveFrom: "opacity-100",
        leaveTo: "opacity-0"
      },
      /* @__PURE__ */ import_react.default.createElement(import_react2.Listbox.Options, { className: "absolute z-40 mt-1 w-full rounded-md bg-white py-1 shadow-lg ring-1 ring-black ring-opacity-5 focus:outline-none text-sm" }, options.length === 0 || isLoading ? /* @__PURE__ */ import_react.default.createElement("div", { className: "relative cursor-default select-none py-2 px-4 text-secondary-700" }, isLoading ? "Loading..." : "No options") : /* @__PURE__ */ import_react.default.createElement("div", { className: "overflow-auto max-h-60" }, options.map((option) => /* @__PURE__ */ import_react.default.createElement(
        import_react2.Listbox.Option,
        {
          key: option.label,
          className: ({ active }) => `relative cursor-default select-none py-2 pl-10 pr-4 text-secondary-800 ${active ? "bg-primary-100" : ""}`,
          value: option
        },
        ({ selected }) => /* @__PURE__ */ import_react.default.createElement(import_react.default.Fragment, null, /* @__PURE__ */ import_react.default.createElement(
          "span",
          {
            title: option.label,
            className: `block truncate ${selected && selectedValue ? "font-medium text-secondary-900" : "font-normal"}`
          },
          option.label
        ), selected && selectedValue ? /* @__PURE__ */ import_react.default.createElement("span", { className: "absolute inset-y-0 left-0 flex items-center pl-3 text-primary-600" }, /* @__PURE__ */ import_react.default.createElement(import_solid.CheckIcon, { className: "h-5 w-5", "aria-hidden": "true" })) : null)
      ))))
    )
  );
}
var select_default = (0, import_react.memo)(Select);

// src/route/select.tsx
function RouteSelect(_a) {
  var _b = _a, {
    options,
    filterName,
    emptyValue,
    multiple
  } = _b, rest = __objRest(_b, [
    "options",
    "filterName",
    "emptyValue",
    "multiple"
  ]);
  const { onChange, selectedOptions } = useRouteSelect(options, filterName, emptyValue);
  if (multiple) {
    return /* @__PURE__ */ import_react3.default.createElement(
      select_default,
      __spreadProps(__spreadValues({}, rest), {
        options,
        selectedOptions,
        onChange,
        multiple: true
      })
    );
  }
  return /* @__PURE__ */ import_react3.default.createElement(
    select_default,
    __spreadProps(__spreadValues({}, rest), {
      options,
      selectedOption: selectedOptions[0] || null,
      onChange
    })
  );
}
var select_default2 = (0, import_react3.memo)(RouteSelect);

// src/route/searchSelect.tsx
var import_react6 = __toESM(require("react"));

// src/searchSelect.tsx
var import_classnames2 = __toESM(require("classnames"));
var import_react4 = __toESM(require("react"));
var import_react5 = require("@headlessui/react");
var import_solid2 = require("@heroicons/react/20/solid");
function SearchSelect({
  className,
  options,
  selectedOption,
  selectedOptions,
  onChange,
  multiple,
  placeholder,
  isLoading,
  filter,
  resetButton = true
}) {
  const [searchQuery, setSearchQuery] = (0, import_react4.useState)("");
  const selectedValue = multiple ? selectedOptions : selectedOption;
  const selectedLabel = multiple ? selectedOptions == null ? void 0 : selectedOptions.map((x) => x.label).join(", ") : selectedOption == null ? void 0 : selectedOption.label;
  const searchString = searchQuery.toLowerCase().replace(/\s+/g, "");
  const currentOptions = searchQuery === "" ? options : options.filter(
    (x) => x.label.toLowerCase().replace(/\s+/g, "").includes(searchString)
  );
  return /* @__PURE__ */ import_react4.default.createElement(
    import_react5.Combobox,
    {
      value: selectedValue || null,
      onChange,
      multiple,
      nullable: true,
      as: "div",
      className: (0, import_classnames2.default)("relative", className)
    },
    /* @__PURE__ */ import_react4.default.createElement(import_react5.Combobox.Button, { as: "div" }, /* @__PURE__ */ import_react4.default.createElement(
      "button",
      {
        type: "button",
        className: (0, import_classnames2.default)(
          "form-input relative w-full cursor-default pl-3 pr-10 text-left",
          filter ? "form-input-filter" : ""
        )
      },
      /* @__PURE__ */ import_react4.default.createElement(
        "span",
        {
          title: selectedLabel,
          className: (0, import_classnames2.default)(
            "block truncate",
            selectedLabel ? "" : "text-secondary-500"
          )
        },
        selectedLabel || placeholder
      ),
      (!resetButton || !selectedLabel) && /* @__PURE__ */ import_react4.default.createElement("span", { className: "pointer-events-none absolute inset-y-0 right-0 flex items-center pr-2" }, /* @__PURE__ */ import_react4.default.createElement(import_solid2.ChevronDownIcon, { className: "h-5 w-5", "aria-hidden": "true" }))
    )),
    resetButton && selectedLabel && /* @__PURE__ */ import_react4.default.createElement(
      "button",
      {
        type: "button",
        className: "form-input-clear absolute z-10 right-2.5 inset-y-0 my-auto h-5 px-0.5",
        onClick: () => {
          if (multiple) {
            onChange([]);
          } else {
            onChange(null);
          }
        }
      },
      /* @__PURE__ */ import_react4.default.createElement(import_solid2.XMarkIcon, { className: "h-4 w-4", "aria-hidden": "true" })
    ),
    /* @__PURE__ */ import_react4.default.createElement(
      import_react5.Transition,
      {
        as: import_react4.Fragment,
        leave: "transition ease-in duration-100",
        leaveFrom: "opacity-100",
        leaveTo: "opacity-0",
        afterLeave: () => {
          setSearchQuery("");
        }
      },
      /* @__PURE__ */ import_react4.default.createElement(import_react5.Combobox.Options, { className: "absolute z-40 mt-1 w-full rounded-md bg-white py-1 shadow-lg ring-1 ring-black ring-opacity-5 focus:outline-none text-sm" }, !isLoading && /* @__PURE__ */ import_react4.default.createElement("div", { className: "relative" }, /* @__PURE__ */ import_react4.default.createElement(
        import_solid2.MagnifyingGlassIcon,
        {
          className: "pointer-events-none absolute top-3.5 left-4 h-5 w-5 text-secondary-400",
          "aria-hidden": "true"
        }
      ), /* @__PURE__ */ import_react4.default.createElement(
        import_react5.Combobox.Input,
        {
          type: "search",
          placeholder: "Search...",
          className: "h-12 w-full bottom-0 border-transparent pl-11 pr-4 text-secondary-800 placeholder-secondary-400 text-sm focus:border-none focus:outline-none focus:ring-0 focus:shadow-none",
          displayValue: () => searchQuery,
          onChange: (event) => {
            setSearchQuery(event.target.value);
          }
        }
      )), currentOptions.length === 0 || isLoading ? /* @__PURE__ */ import_react4.default.createElement("div", { className: "relative cursor-default select-none py-2 px-4 text-secondary-700" }, isLoading ? "Loading..." : "No options") : /* @__PURE__ */ import_react4.default.createElement("div", { className: "overflow-auto max-h-60" }, currentOptions.map((option) => /* @__PURE__ */ import_react4.default.createElement(
        import_react5.Combobox.Option,
        {
          key: option.label,
          className: ({ active }) => `relative cursor-default select-none py-2 pl-10 pr-4 text-secondary-800 ${active ? "bg-primary-100" : ""}`,
          value: option
        },
        ({ selected }) => /* @__PURE__ */ import_react4.default.createElement(import_react4.default.Fragment, null, /* @__PURE__ */ import_react4.default.createElement(
          "span",
          {
            title: option.label,
            className: `block truncate ${selected && selectedValue ? "font-medium text-secondary-900" : "font-normal"}`
          },
          option.label
        ), selected && selectedValue ? /* @__PURE__ */ import_react4.default.createElement("span", { className: "absolute inset-y-0 left-0 flex items-center pl-3 text-primary-600" }, /* @__PURE__ */ import_react4.default.createElement(import_solid2.CheckIcon, { className: "h-5 w-5", "aria-hidden": "true" })) : null)
      ))))
    )
  );
}
var searchSelect_default = (0, import_react4.memo)(SearchSelect);

// src/route/searchSelect.tsx
function RouteSearchSelect(_a) {
  var _b = _a, {
    options,
    filterName,
    emptyValue,
    multiple
  } = _b, rest = __objRest(_b, [
    "options",
    "filterName",
    "emptyValue",
    "multiple"
  ]);
  const { onChange, selectedOptions } = useRouteSelect(options, filterName, emptyValue);
  if (multiple) {
    return /* @__PURE__ */ import_react6.default.createElement(
      searchSelect_default,
      __spreadProps(__spreadValues({}, rest), {
        options,
        selectedOptions,
        onChange,
        multiple: true
      })
    );
  }
  return /* @__PURE__ */ import_react6.default.createElement(
    searchSelect_default,
    __spreadProps(__spreadValues({}, rest), {
      options,
      selectedOption: selectedOptions[0] || null,
      onChange
    })
  );
}
var searchSelect_default2 = (0, import_react6.memo)(RouteSearchSelect);

// src/combobox.tsx
var import_react7 = __toESM(require("react"));
function Combobox2(props) {
  if (props.options.length > 6) {
    return /* @__PURE__ */ import_react7.default.createElement(searchSelect_default, __spreadValues({}, props));
  }
  return /* @__PURE__ */ import_react7.default.createElement(select_default, __spreadValues({}, props));
}
var combobox_default = (0, import_react7.memo)(Combobox2);

// src/route/combobox.tsx
var import_react8 = __toESM(require("react"));
function RouteCombobox(props) {
  if (props.options.length > 6) {
    return /* @__PURE__ */ import_react8.default.createElement(searchSelect_default2, __spreadValues({}, props));
  }
  return /* @__PURE__ */ import_react8.default.createElement(select_default2, __spreadValues({}, props));
}
var combobox_default2 = (0, import_react8.memo)(RouteCombobox);

// src/route/autocomplete.tsx
var import_react11 = __toESM(require("react"));

// src/autocomplete.tsx
var import_classnames3 = __toESM(require("classnames"));
var import_react9 = __toESM(require("react"));
var import_react10 = require("@headlessui/react");
var import_solid3 = require("@heroicons/react/20/solid");
function Autocomplete({
  className,
  options,
  selectedOption,
  onChange,
  placeholder,
  isLoading,
  filter,
  searchQuery,
  onSearch,
  minQueryLength = 2,
  resetButton = true
}) {
  const selectedValue = selectedOption;
  const selectedLabel = (selectedOption == null ? void 0 : selectedOption.label) || "";
  const emptyMessage = searchQuery.length < minQueryLength ? `Type at least ${minQueryLength} symbols` : "Nothing found";
  const showOptions = options.length > 0 && !isLoading && searchQuery.length >= minQueryLength;
  return /* @__PURE__ */ import_react9.default.createElement(
    import_react10.Combobox,
    {
      value: selectedValue,
      onChange,
      nullable: true,
      as: "div",
      className: (0, import_classnames3.default)("relative", className)
    },
    /* @__PURE__ */ import_react9.default.createElement(
      import_react10.Combobox.Input,
      {
        placeholder,
        className: (0, import_classnames3.default)(
          "form-input relative w-full cursor-default pl-3 pr-10 text-left truncate placeholder-secondary-500",
          filter ? "form-input-filter" : ""
        ),
        displayValue: () => searchQuery || selectedLabel,
        onChange: ({ target }) => {
          const { value } = target;
          onSearch(value, value.length >= minQueryLength);
        }
      }
    ),
    resetButton && selectedValue && /* @__PURE__ */ import_react9.default.createElement(
      "button",
      {
        type: "button",
        className: "form-input-clear absolute z-10 right-2.5 inset-y-0 my-auto h-5 px-0.5",
        onClick: () => {
          onChange(null);
        }
      },
      /* @__PURE__ */ import_react9.default.createElement(
        import_solid3.XMarkIcon,
        {
          className: "h-4 w-4",
          "aria-hidden": "true"
        }
      )
    ),
    /* @__PURE__ */ import_react9.default.createElement(
      import_react10.Transition,
      {
        as: import_react9.Fragment,
        leave: "transition ease-in duration-100",
        leaveFrom: "opacity-100",
        leaveTo: "opacity-0",
        afterLeave: () => {
          onSearch("", false);
        }
      },
      /* @__PURE__ */ import_react9.default.createElement(import_react10.Combobox.Options, { className: "absolute z-40 mt-1 w-full rounded-md bg-white py-1 shadow-lg ring-1 ring-black ring-opacity-5 focus:outline-none text-sm" }, !showOptions ? /* @__PURE__ */ import_react9.default.createElement("div", { className: "relative cursor-default select-none py-2 px-4 text-secondary-700" }, isLoading ? "Loading..." : emptyMessage) : /* @__PURE__ */ import_react9.default.createElement("div", { className: "overflow-auto max-h-60" }, options.map((option) => /* @__PURE__ */ import_react9.default.createElement(
        import_react10.Combobox.Option,
        {
          key: option.label,
          className: ({ active }) => `relative cursor-default select-none py-2 pl-10 pr-4 text-secondary-800 ${active ? "bg-primary-100" : ""}`,
          value: option
        },
        ({ selected }) => /* @__PURE__ */ import_react9.default.createElement(import_react9.default.Fragment, null, /* @__PURE__ */ import_react9.default.createElement(
          "span",
          {
            title: option.label,
            className: `block truncate ${selected && selectedValue ? "font-medium text-secondary-900" : "font-normal"}`
          },
          option.label
        ), selected && selectedValue ? /* @__PURE__ */ import_react9.default.createElement("span", { className: "absolute inset-y-0 left-0 flex items-center pl-3 text-primary-600" }, /* @__PURE__ */ import_react9.default.createElement(import_solid3.CheckIcon, { className: "h-5 w-5", "aria-hidden": "true" })) : null)
      ))))
    )
  );
}
var autocomplete_default = (0, import_react9.memo)(Autocomplete);

// src/route/autocomplete.tsx
function RouteAutocomplete(_a) {
  var _b = _a, {
    options,
    filterName,
    emptyValue
  } = _b, rest = __objRest(_b, [
    "options",
    "filterName",
    "emptyValue"
  ]);
  const { onChange, selectedOptions, optionValues } = useRouteSelect(
    options,
    filterName,
    emptyValue
  );
  const [value] = optionValues;
  const selectedValue = value ? { label: value, value } : null;
  return /* @__PURE__ */ import_react11.default.createElement(
    autocomplete_default,
    __spreadProps(__spreadValues({}, rest), {
      options,
      selectedOption: selectedOptions[0] || selectedValue,
      onChange
    })
  );
}
var autocomplete_default2 = (0, import_react11.memo)(RouteAutocomplete);

// src/route/treeSelect.tsx
var import_react14 = __toESM(require("react"));

// src/treeSelect.tsx
var import_classnames4 = __toESM(require("classnames"));
var import_react12 = __toESM(require("react"));
var import_react13 = require("@headlessui/react");
var import_solid4 = require("@heroicons/react/20/solid");

// src/common/utils.ts
function getOptions(nodes) {
  const options = [];
  for (let i = 0; i < nodes.length; i++) {
    const node = nodes[i];
    if (node.children) {
      options.push(...getOptions(node.children));
    } else {
      options.push(node);
    }
  }
  return options;
}

// src/treeSelect.tsx
function filterNodes(treeData, searchString) {
  const treeNodes = [];
  for (let i = 0; i < treeData.length; i++) {
    const node = treeData[i];
    if (node.label.toLowerCase().replace(/\s+/g, "").includes(searchString)) {
      treeNodes.push(node);
      continue;
    }
    if (node.children) {
      const children = filterNodes(node.children, searchString);
      if (children.length > 0) {
        treeNodes.push(__spreadProps(__spreadValues({}, node), {
          children
        }));
      }
    }
  }
  return treeNodes;
}
function getSelection(node, selectionSet, selectionCache) {
  if (selectionCache.has(node)) {
    return selectionCache.get(node);
  }
  for (let i = 0; i < node.children.length; i++) {
    const child = node.children[i];
    let selection;
    if (child.children) {
      selection = getSelection(child, selectionSet, selectionCache);
    } else {
      selection = selectionSet.has(child);
    }
    if (!selection) {
      selectionCache.set(node, false);
      return false;
    }
  }
  selectionCache.set(node, true);
  return true;
}
function TreeGroupOption(_a) {
  var _b = _a, {
    node
  } = _b, rest = __objRest(_b, [
    "node"
  ]);
  const { selectionSet, selectionCache, onChange } = rest;
  const selected = getSelection(node, selectionSet, selectionCache);
  return /* @__PURE__ */ import_react12.default.createElement("div", null, /* @__PURE__ */ import_react12.default.createElement(
    "div",
    {
      onClick: () => {
        if (onChange) {
          const selectionSetClone = new Set(selectionSet);
          const options = getOptions(node.children);
          if (selected) {
            options.forEach((option) => {
              selectionSetClone.delete(option);
            });
          } else {
            options.forEach((option) => {
              selectionSetClone.add(option);
            });
          }
          onChange(Array.from(selectionSetClone));
        }
      },
      className: `relative select-none py-2 pl-10 pr-4 text-secondary-800 ${onChange ? "hover:bg-primary-100" : ""}`
    },
    /* @__PURE__ */ import_react12.default.createElement(
      "span",
      {
        title: node.label,
        className: `block truncate ${selected ? "font-medium text-secondary-900" : "font-normal"}`
      },
      node.label
    ),
    selected ? /* @__PURE__ */ import_react12.default.createElement("span", { className: "absolute inset-y-0 left-0 flex items-center pl-3 text-primary-600" }, /* @__PURE__ */ import_react12.default.createElement(import_solid4.CheckIcon, { className: "h-5 w-5", "aria-hidden": "true" })) : null
  ), /* @__PURE__ */ import_react12.default.createElement("div", { className: "pl-10" }, /* @__PURE__ */ import_react12.default.createElement(TreeOptions, __spreadValues({ nodes: node.children }, rest))));
}
function TreeOptions(_a) {
  var _b = _a, {
    nodes
  } = _b, rest = __objRest(_b, [
    "nodes"
  ]);
  return /* @__PURE__ */ import_react12.default.createElement(import_react12.default.Fragment, null, nodes.map((node) => {
    if (node.children) {
      return /* @__PURE__ */ import_react12.default.createElement(TreeGroupOption, __spreadProps(__spreadValues({}, rest), { key: node.label, node }));
    }
    return /* @__PURE__ */ import_react12.default.createElement(
      import_react13.Combobox.Option,
      {
        key: node.label,
        className: ({ active }) => `relative cursor-default select-none py-2 pl-10 pr-4 text-secondary-800 ${active ? "bg-primary-100" : ""}`,
        value: node
      },
      ({ selected }) => /* @__PURE__ */ import_react12.default.createElement(import_react12.default.Fragment, null, /* @__PURE__ */ import_react12.default.createElement(
        "span",
        {
          title: node.label,
          className: `block truncate ${selected ? "font-medium text-secondary-900" : "font-normal"}`
        },
        node.label
      ), selected ? /* @__PURE__ */ import_react12.default.createElement("span", { className: "absolute inset-y-0 left-0 flex items-center pl-3 text-primary-600" }, /* @__PURE__ */ import_react12.default.createElement(import_solid4.CheckIcon, { className: "h-5 w-5", "aria-hidden": "true" })) : null)
    );
  }));
}
function TreeSelect({
  className,
  treeData,
  selectedOption,
  selectedOptions,
  onChange,
  multiple,
  placeholder,
  isLoading,
  filter,
  resetButton = true
}) {
  const [searchQuery, setSearchQuery] = (0, import_react12.useState)("");
  const selectedValue = multiple ? selectedOptions : selectedOption;
  const selectedLabel = multiple ? selectedOptions == null ? void 0 : selectedOptions.map((x) => x.label).join(", ") : selectedOption == null ? void 0 : selectedOption.label;
  const treeNodes = searchQuery === "" ? treeData : filterNodes(treeData, searchQuery.toLowerCase().replace(/\s+/g, ""));
  const selectionSet = new Set(
    multiple ? selectedOptions : selectedOption ? [selectedOption] : []
  );
  const selectionCache = /* @__PURE__ */ new Map();
  return /* @__PURE__ */ import_react12.default.createElement(
    import_react13.Combobox,
    {
      value: selectedValue || null,
      onChange,
      multiple,
      nullable: true,
      as: "div",
      className: (0, import_classnames4.default)("relative", className)
    },
    /* @__PURE__ */ import_react12.default.createElement(import_react13.Combobox.Button, { as: "div" }, /* @__PURE__ */ import_react12.default.createElement(
      "button",
      {
        type: "button",
        className: (0, import_classnames4.default)(
          "form-input relative w-full cursor-default pl-3 pr-10 text-left",
          filter ? "form-input-filter" : ""
        )
      },
      /* @__PURE__ */ import_react12.default.createElement(
        "span",
        {
          title: selectedLabel,
          className: (0, import_classnames4.default)(
            "block truncate",
            selectedLabel ? "" : "text-secondary-500"
          )
        },
        selectedLabel || placeholder
      ),
      (!resetButton || !selectedLabel) && /* @__PURE__ */ import_react12.default.createElement("span", { className: "pointer-events-none absolute inset-y-0 right-0 flex items-center pr-2" }, /* @__PURE__ */ import_react12.default.createElement(import_solid4.ChevronDownIcon, { className: "h-5 w-5", "aria-hidden": "true" }))
    )),
    resetButton && selectedLabel && /* @__PURE__ */ import_react12.default.createElement(
      "button",
      {
        type: "button",
        className: "form-input-clear absolute z-10 right-2.5 inset-y-0 my-auto h-5 px-0.5",
        onClick: () => {
          if (multiple) {
            onChange([]);
          } else {
            onChange(null);
          }
        }
      },
      /* @__PURE__ */ import_react12.default.createElement(import_solid4.XMarkIcon, { className: "h-4 w-4", "aria-hidden": "true" })
    ),
    /* @__PURE__ */ import_react12.default.createElement(
      import_react13.Transition,
      {
        as: import_react12.Fragment,
        leave: "transition ease-in duration-100",
        leaveFrom: "opacity-100",
        leaveTo: "opacity-0",
        afterLeave: () => {
          setSearchQuery("");
        }
      },
      /* @__PURE__ */ import_react12.default.createElement(import_react13.Combobox.Options, { className: "absolute z-40 mt-1 w-full rounded-md bg-white py-1 shadow-lg ring-1 ring-black ring-opacity-5 focus:outline-none text-sm" }, !isLoading && /* @__PURE__ */ import_react12.default.createElement("div", { className: "relative" }, /* @__PURE__ */ import_react12.default.createElement(
        import_solid4.MagnifyingGlassIcon,
        {
          className: "pointer-events-none absolute top-3.5 left-4 h-5 w-5 text-secondary-400",
          "aria-hidden": "true"
        }
      ), /* @__PURE__ */ import_react12.default.createElement(
        import_react13.Combobox.Input,
        {
          type: "search",
          placeholder: "Search...",
          className: "h-12 w-full bottom-0 border-transparent pl-11 pr-4 text-secondary-800 placeholder-secondary-400 text-sm focus:border-none focus:outline-none focus:ring-0 focus:shadow-none",
          displayValue: () => searchQuery,
          onChange: (event) => {
            setSearchQuery(event.target.value);
          }
        }
      )), treeNodes.length === 0 || isLoading ? /* @__PURE__ */ import_react12.default.createElement("div", { className: "relative cursor-default select-none py-2 px-4 text-secondary-700" }, isLoading ? "Loading..." : "No options") : /* @__PURE__ */ import_react12.default.createElement("div", { className: "overflow-auto max-h-60" }, /* @__PURE__ */ import_react12.default.createElement(
        TreeOptions,
        {
          nodes: treeNodes,
          selectionSet,
          selectionCache,
          onChange: multiple ? onChange : void 0
        }
      )))
    )
  );
}
var treeSelect_default = (0, import_react12.memo)(TreeSelect);

// src/route/treeSelect.tsx
function RouteTreeSelect(_a) {
  var _b = _a, {
    treeData,
    filterName,
    emptyValue,
    multiple
  } = _b, rest = __objRest(_b, [
    "treeData",
    "filterName",
    "emptyValue",
    "multiple"
  ]);
  const { onChange, selectedOptions } = useRouteSelect(
    getOptions(treeData),
    filterName,
    emptyValue
  );
  if (multiple) {
    return /* @__PURE__ */ import_react14.default.createElement(
      treeSelect_default,
      __spreadProps(__spreadValues({}, rest), {
        treeData,
        selectedOptions,
        onChange,
        multiple: true
      })
    );
  }
  return /* @__PURE__ */ import_react14.default.createElement(
    treeSelect_default,
    __spreadProps(__spreadValues({}, rest), {
      treeData,
      selectedOption: selectedOptions[0] || null,
      onChange
    })
  );
}
var treeSelect_default2 = (0, import_react14.memo)(RouteTreeSelect);

// src/route/index.tsx
var route_default = select_default2;
